package sbc.mgclus.data;

import java.util.ArrayList;

public class Cluster implements Comparable<Object>{
	private Integer clusterID;
	private ArrayList<Vertex> members;
	private double clusterEfficiency;
	private double degree;
	private int seedCount;
	
	public Cluster (int id){
		clusterID = id;
		members = new ArrayList<Vertex>();
		clusterEfficiency = 0;
		setSeedCount(0);
	}
	
	public void setClusterID (int i){
		clusterID = i;
	}
	
	public int getClusterID (){
		return clusterID;
	}
	
	public void addMember (Vertex v){
		members.add(v);
	}
	
	public ArrayList<Vertex> getMembers (){
		return members;
	}
	
	public void addMemberList (ArrayList<Vertex> m){
		members.addAll(m);	
	}

	public void setClusterEfficiency(double clusterEfficiency) {
		this.clusterEfficiency = clusterEfficiency;
	}

	public double getClusterEfficiency() {
		return clusterEfficiency;
	}
	
	public int getClusterSize(){
		return members.size();
	}
	
	public boolean equals(Object obj) {
	     if (this==obj) {
	        return true;
	     }
	     if (obj==null) {
	        return false;
	     }
	     if (!(obj instanceof Cluster )) {
	        return false;
	     }
	     Cluster other = (Cluster) obj;
	     if (this.clusterID==other.clusterID) {
	        return true;
	     }
	     if (this.clusterID==null && other.clusterID!=null) {
	        return false;
	     }
	     return this.clusterID.equals(other.clusterID);
	  }
	
	public int hashCode() {
	    if (this.clusterID==null) {
	       return 0;
	    }
	    return this.clusterID.hashCode();
	 }

	public void setDegree(double degree) {
		this.degree = degree;
	}

	public double getDegree() {
		return degree;
	}
	
	public int compareTo(Object c){
	    if (this.getClusterSize() < ((Cluster)c).getClusterSize())
	    	return 1;
	    else if (this.getClusterSize() > ((Cluster)c).getClusterSize())
	    	return -1;
	    else
	    	return 0;
	}

	public void setSeedCount(int seedCount) {
		this.seedCount = seedCount;
	}

	public int getSeedCount() {
		return seedCount;
	}
	
}
